    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * LengthConstraintType.java
    029     * -------------------------
    030     * (C) Copyright 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: LengthConstraintType.java,v 1.2.2.1 2005/10/25 20:39:38 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 08-Feb-2004 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.block;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Defines tokens used to indicate a length constraint type.
    050     */
    051    public final class LengthConstraintType implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = -1156658804028142978L;
    055
    056        /** NONE. */
    057        public static final LengthConstraintType NONE
    058            = new LengthConstraintType("LengthConstraintType.NONE");
    059
    060        /** Range. */
    061        public static final LengthConstraintType RANGE
    062            = new LengthConstraintType("RectangleConstraintType.RANGE");
    063
    064        /** FIXED. */
    065        public static final LengthConstraintType FIXED
    066            = new LengthConstraintType("LengthConstraintType.FIXED");
    067
    068        /** The name. */
    069        private String name;
    070
    071        /**
    072         * Private constructor.
    073         *
    074         * @param name  the name.
    075         */
    076        private LengthConstraintType(String name) {
    077            this.name = name;
    078        }
    079
    080        /**
    081         * Returns a string representing the object.
    082         *
    083         * @return The string.
    084         */
    085        public String toString() {
    086            return this.name;
    087        }
    088
    089        /**
    090         * Returns <code>true</code> if this object is equal to the specified
    091         * object, and <code>false</code> otherwise.
    092         *
    093         * @param obj  the object (<code>null</code> permitted).
    094         *
    095         * @return A boolean.
    096         */
    097        public boolean equals(Object obj) {
    098            if (this == obj) {
    099                return true;
    100            }
    101            if (!(obj instanceof LengthConstraintType)) {
    102                return false;
    103            }
    104            LengthConstraintType that = (LengthConstraintType) obj;
    105            if (!this.name.equals(that.toString())) {
    106                return false;
    107            }
    108            return true;
    109        }
    110
    111        /**
    112         * Returns a hash code value for the object.
    113         *
    114         * @return The hashcode
    115         */
    116        public int hashCode() {
    117            return this.name.hashCode();
    118        }
    119
    120        /**
    121         * Ensures that serialization returns the unique instances.
    122         *
    123         * @return The object.
    124         *
    125         * @throws ObjectStreamException if there is a problem.
    126         */
    127        private Object readResolve() throws ObjectStreamException {
    128            if (this.equals(LengthConstraintType.NONE)) {
    129                return LengthConstraintType.NONE;
    130            }
    131            else if (this.equals(LengthConstraintType.RANGE)) {
    132                return LengthConstraintType.RANGE;
    133            }
    134            else if (this.equals(LengthConstraintType.FIXED)) {
    135                return LengthConstraintType.FIXED;
    136            }
    137            return null;
    138        }
    139
    140    }